Index: /palm/trunk/SOURCE/diffusion_u.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_u.f90	(revision 2036)
+++ /palm/trunk/SOURCE/diffusion_u.f90	(revision 2037)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Anelastic approximation implemented
 ! 
 ! Former revisions:
@@ -116,5 +116,6 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, ddzw, km, tend, u, usws, uswst, v, w
+           ONLY:  ddzu, ddzw, km, tend, u, usws, uswst, v, w,                  &
+                  drho_air, rho_air_zw
        
        USE control_parameters,                                                 &
@@ -217,9 +218,9 @@
                       & + ( kmzp * ( ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)   &
                       &            + ( w(k,j,i)   - w(k,j,i-1) ) * ddx         &
-                      &            )                                           &
+                      &            ) * rho_air_zw(k)                           &
                       &   - kmzm * ( ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)   &
                       &            + ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx       &
-                      &            )                                           &
-                      &   ) * ddzw(k)
+                      &            ) * rho_air_zw(k-1)                         &
+                      &   ) * ddzw(k) * drho_air(k)
              ENDDO
 
@@ -242,9 +243,9 @@
 
                 tend(k,j,i) = tend(k,j,i)                                      &
-                      & + ( kmzp * ( w(k,j,i)   - w(k,j,i-1)   ) * ddx         &
-                      &   ) * ddzw(k)                                          &
-                      & + ( kmzp * ( u(k+1,j,i) - u(k,j,i)     ) * ddzu(k+1)   &
-                      &   + usws(j,i)                                          &
-                      &   ) * ddzw(k)
+                      & + ( kmzp * ( ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)   &
+                      &            + ( w(k,j,i)   - w(k,j,i-1) ) * ddx         &
+                      &            ) * rho_air_zw(k)                           &
+                      &   - ( -usws(j,i) )                                     &
+                      &   ) * ddzw(k) * drho_air(k)
              ENDIF
 
@@ -260,9 +261,9 @@
 
                 tend(k,j,i) = tend(k,j,i)                                      &
-                      & - ( kmzm * ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx         &
-                      &   ) * ddzw(k)                                          &
-                      & + ( -uswst(j,i)                                        &
-                      &   - kmzm * ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)     &
-                      &   ) * ddzw(k)
+                      & + ( ( -uswst(j,i) )                                    &
+                      &   - kmzm * ( ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)   &
+                      &            + ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx       &
+                      &            ) * rho_air_zw(k-1)                         &
+                      &   ) * ddzw(k) * drho_air(k)
              ENDIF
 
@@ -281,5 +282,6 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, ddzw, km, tend, u, usws, uswst, v, w
+           ONLY:  ddzu, ddzw, km, tend, u, usws, uswst, v, w,                  &
+                  drho_air, rho_air_zw
        
        USE control_parameters,                                                 &
@@ -390,9 +392,9 @@
                          & + ( kmzp * ( ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)&
                          &            + ( w(k,j,i)   - w(k,j,i-1) ) * ddx      &
-                         &            )                                        &
+                         &            ) * rho_air_zw(k)                        &
                          &   - kmzm * ( ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)&
                          &            + ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx    &
-                         &            )                                        &
-                         &   ) * ddzw(k)
+                         &            ) * rho_air_zw(k-1)                      &
+                         &   ) * ddzw(k) * drho_air(k)
                 ENDIF
              ENDDO
@@ -423,9 +425,9 @@
 
                 tend(k,j,i) = tend(k,j,i)                                      &
-                      & + ( kmzp * ( w(k,j,i)   - w(k,j,i-1)   ) * ddx         &
-                      &   ) * ddzw(k)                                          &
-                      & + ( kmzp * ( u(k+1,j,i) - u(k,j,i)     ) * ddzu(k+1)   &
-                      &   + usws(j,i)                                          &
-                      &   ) * ddzw(k)
+                      & + ( kmzp * ( ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)   &
+                      &            + ( w(k,j,i)   - w(k,j,i-1) ) * ddx         &
+                      &            ) * rho_air_zw(k)                           &
+                      &   - ( -usws(j,i) )                                     &
+                      &   ) * ddzw(k) * drho_air(k)
              ENDDO
           ENDDO
@@ -449,9 +451,9 @@
 
                 tend(k,j,i) = tend(k,j,i)                                      &
-                      & - ( kmzm * ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx         &
-                      &   ) * ddzw(k)                                          &
-                      & + ( -uswst(j,i)                                        &
-                      &   - kmzm * ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)     &
-                      &   ) * ddzw(k)
+                      & + ( ( -uswst(j,i) )                                    &
+                      &   - kmzm * ( ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)   &
+                      &            + ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx       &
+                      &            ) * rho_air_zw(k-1)                         &
+                      &   ) * ddzw(k) * drho_air(k)
              ENDDO
           ENDDO
@@ -471,5 +473,6 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, ddzw, km, tend, u, usws, uswst, v, w
+           ONLY:  ddzu, ddzw, km, tend, u, usws, uswst, v, w,                  &
+                  drho_air, rho_air_zw
        
        USE control_parameters,                                                 &
@@ -559,9 +562,9 @@
                       & + ( kmzp * ( ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)   &
                       &            + ( w(k,j,i)   - w(k,j,i-1) ) * ddx         &
-                      &            )                                           &
+                      &            ) * rho_air_zw(k)                           &
                       &   - kmzm * ( ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)   &
                       &            + ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx       &
-                      &            )                                           &
-                      &   ) * ddzw(k)
+                      &            ) * rho_air_zw(k-1)                         &
+                      &   ) * ddzw(k) * drho_air(k)
        ENDDO
 
@@ -583,9 +586,9 @@
 
           tend(k,j,i) = tend(k,j,i)                                            &
-                      & + ( kmzp * ( w(k,j,i)   - w(k,j,i-1)   ) * ddx         &
-                      &   ) * ddzw(k)                                          &
-                      & + ( kmzp * ( u(k+1,j,i) - u(k,j,i)     ) * ddzu(k+1)   &
-                      &   + usws(j,i)                                          &
-                      &   ) * ddzw(k)
+                      & + ( kmzp * ( ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)   &
+                      &            + ( w(k,j,i)   - w(k,j,i-1) ) * ddx         &
+                      &            ) * rho_air_zw(k)                           &
+                      &   - ( -usws(j,i) )                                     &
+                      &   ) * ddzw(k) * drho_air(k)
        ENDIF
 
@@ -597,13 +600,12 @@
 !
 !--       Interpolate eddy diffusivities on staggered gridpoints
-          kmzm = 0.25_wp *                                                     &
-                 ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
+          kmzm = 0.25_wp * ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
 
           tend(k,j,i) = tend(k,j,i)                                            &
-                      & - ( kmzm * ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx         &
-                      &   ) * ddzw(k)                                          &
-                      & + ( -uswst(j,i)                                        &
-                      &   - kmzm * ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)     &
-                      &   ) * ddzw(k)
+                      & + ( ( -uswst(j,i) )                                    &
+                      &   - kmzm * ( ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)   &
+                      &            + ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx       &
+                      &            ) * rho_air_zw(k-1)                         &
+                      &   ) * ddzw(k) * drho_air(k)
        ENDIF
 
Index: /palm/trunk/SOURCE/diffusion_v.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_v.f90	(revision 2036)
+++ /palm/trunk/SOURCE/diffusion_v.f90	(revision 2037)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Anelastic approximation implemented
 ! 
 ! Former revisions:
@@ -111,5 +111,6 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, ddzw, km, tend, u, v, vsws, vswst, w
+           ONLY:  ddzu, ddzw, km, tend, u, v, vsws, vswst, w,                  &
+                  drho_air, rho_air_zw
        
        USE control_parameters,                                                 &
@@ -212,9 +213,9 @@
                       & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1)     &
                       &            + ( w(k,j,i) - w(k,j-1,i) ) * ddy           &
-                      &            )                                           &
+                      &            ) * rho_air_zw(k)                           &
                       &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k)   &
                       &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy       &
-                      &            )                                           &
-                      &   ) * ddzw(k)
+                      &            ) * rho_air_zw(k-1)                         &
+                      &   ) * ddzw(k) * drho_air(k)
              ENDDO
 
@@ -237,9 +238,9 @@
 
                 tend(k,j,i) = tend(k,j,i)                                      &
-                      & + ( kmzp * ( w(k,j,i) - w(k,j-1,i)     ) * ddy         &
-                      &   ) * ddzw(k)                                          &
-                      & + ( kmzp * ( v(k+1,j,i) - v(k,j,i)     ) * ddzu(k+1)   &
-                      &   + vsws(j,i)                                          &
-                      &   ) * ddzw(k)
+                      & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i)   ) * ddzu(k+1)   &
+                      &            + ( w(k,j,i)   - w(k,j-1,i) ) * ddy         &
+                      &            ) * rho_air_zw(k)                           &
+                      &   - ( -vsws(j,i) )                                     &
+                      &   ) * ddzw(k) * drho_air(k)
              ENDIF
 
@@ -255,9 +256,9 @@
 
                 tend(k,j,i) = tend(k,j,i)                                      &
-                      & - ( kmzm *  ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy        &
-                      &   ) * ddzw(k)                                          &
-                      & + ( -vswst(j,i)                                        &
-                      &   - kmzm * ( v(k,j,i)   - v(k-1,j,i)    ) * ddzu(k)    &
-                      &   ) * ddzw(k)
+                      & + ( ( -vswst(j,i) )                                    &
+                      &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k)   &
+                      &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy       &
+                      &            ) * rho_air_zw(k-1)                         &
+                      &   ) * ddzw(k) * drho_air(k)
              ENDIF
 
@@ -276,5 +277,6 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, ddzw, km, tend, u, v, vsws, vswst, w
+           ONLY:  ddzu, ddzw, km, tend, u, v, vsws, vswst, w,                  &
+                  drho_air, rho_air_zw
        
        USE control_parameters,                                                 &
@@ -385,9 +387,9 @@
                          & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i)   ) * ddzu(k+1)&
                          &            + ( w(k,j,i)   - w(k,j-1,i) ) * ddy      &
-                         &            )                                        &
+                         &            ) * rho_air_zw(k)                        &
                          &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k)&
                          &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy    &
-                         &            )                                        &
-                         &   ) * ddzw(k)
+                         &            ) * rho_air_zw(k-1)                      &
+                         &   ) * ddzw(k) * drho_air(k)
                 ENDIF
              ENDDO
@@ -418,9 +420,9 @@
 
                 tend(k,j,i) = tend(k,j,i)                                      &
-                      & + ( kmzp * ( w(k,j,i) - w(k,j-1,i)     ) * ddy         &
-                      &   ) * ddzw(k)                                          &
-                      & + ( kmzp * ( v(k+1,j,i) - v(k,j,i)     ) * ddzu(k+1)   &
-                      &   + vsws(j,i)                                          &
-                      &   ) * ddzw(k)
+                      & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i)   ) * ddzu(k+1)   &
+                      &            + ( w(k,j,i)   - w(k,j-1,i) ) * ddy         &
+                      &            ) * rho_air_zw(k)                           &
+                      &   - ( -vsws(j,i) )                                     &
+                      &   ) * ddzw(k) * drho_air(k)
              ENDDO
           ENDDO
@@ -444,9 +446,9 @@
 
                 tend(k,j,i) = tend(k,j,i)                                      &
-                      & - ( kmzm *  ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy        &
-                      &   ) * ddzw(k)                                          &
-                      & + ( -vswst(j,i)                                        &
-                      &   - kmzm * ( v(k,j,i)   - v(k-1,j,i)    ) * ddzu(k)    &
-                      &   ) * ddzw(k)
+                      & + ( ( -vswst(j,i) )                                    &
+                      &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k)   &
+                      &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy       &
+                      &            ) * rho_air_zw(k-1)                         &
+                      &   ) * ddzw(k) * drho_air(k)
              ENDDO
           ENDDO
@@ -466,5 +468,6 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, ddzw, km, tend, u, v, vsws, vswst, w
+           ONLY:  ddzu, ddzw, km, tend, u, v, vsws, vswst, w,                  &
+                  drho_air, rho_air_zw
        
        USE control_parameters,                                                 &
@@ -556,9 +559,9 @@
                       & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i) ) * ddzu(k+1)     &
                       &            + ( w(k,j,i) - w(k,j-1,i) ) * ddy           &
-                      &            )                                           &
+                      &            ) * rho_air_zw(k)                           &
                       &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k)   &
                       &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy       &
-                      &            )                                           &
-                      &   ) * ddzw(k)
+                      &            ) * rho_air_zw(k-1)                         &
+                      &   ) * ddzw(k) * drho_air(k)
        ENDDO
 
@@ -580,9 +583,9 @@
 
           tend(k,j,i) = tend(k,j,i)                                            &
-                      & + ( kmzp * ( w(k,j,i) - w(k,j-1,i)     ) * ddy         &
-                      &   ) * ddzw(k)                                          &
-                      & + ( kmzp * ( v(k+1,j,i) - v(k,j,i)     ) * ddzu(k+1)   &
-                      &   + vsws(j,i)                                          &
-                      &   ) * ddzw(k)
+                      & + ( kmzp * ( ( v(k+1,j,i) - v(k,j,i)   ) * ddzu(k+1)   &
+                      &            + ( w(k,j,i)   - w(k,j-1,i) ) * ddy         &
+                      &            ) * rho_air_zw(k)                           &
+                      &   - ( -vsws(j,i) )                                     &
+                      &   ) * ddzw(k) * drho_air(k)
        ENDIF
 
@@ -594,13 +597,12 @@
 !
 !--       Interpolate eddy diffusivities on staggered gridpoints
-          kmzm = 0.25_wp * &
-                 ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
+          kmzm = 0.25_wp * ( km(k,j,i)+km(k-1,j,i)+km(k,j-1,i)+km(k-1,j-1,i) )
 
           tend(k,j,i) = tend(k,j,i)                                            &
-                      & - ( kmzm *  ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy        &
-                      &   ) * ddzw(k)                                          &
-                      & + ( -vswst(j,i)                                        &
-                      &   - kmzm * ( v(k,j,i)   - v(k-1,j,i)    ) * ddzu(k)    &
-                      &   ) * ddzw(k)
+                      & + ( ( -vswst(j,i) )                                    &
+                      &   - kmzm * ( ( v(k,j,i)   - v(k-1,j,i)   ) * ddzu(k)   &
+                      &            + ( w(k-1,j,i) - w(k-1,j-1,i) ) * ddy       &
+                      &            ) * rho_air_zw(k-1)                         &
+                      &   ) * ddzw(k) * drho_air(k)
        ENDIF
 
Index: /palm/trunk/SOURCE/diffusion_w.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_w.f90	(revision 2036)
+++ /palm/trunk/SOURCE/diffusion_w.f90	(revision 2037)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Anelastic approximation implemented
 ! 
 ! Former revisions:
@@ -119,5 +119,5 @@
 
        USE arrays_3d,                                                          &          
-           ONLY :  ddzu, ddzw, km, tend, u, v, w
+           ONLY :  ddzu, ddzw, km, tend, u, v, w, drho_air_zw, rho_air
            
        USE control_parameters,                                                 & 
@@ -184,6 +184,8 @@
                       & + 2.0_wp * (                                           &
                       &   km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1)  &
+                      &               * rho_air(k+1)                           &
                       & - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k)  &
-                      &            ) * ddzu(k+1)
+                      &               * rho_air(k)                             &
+                      &            ) * ddzu(k+1) * drho_air_zw(k)
              ENDDO
 
@@ -227,6 +229,8 @@
                                  + 2.0_wp * (                                  &
                            km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1) &
+                                       * rho_air(k+1)                          &
                          - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k) &
-                                            ) * ddzu(k+1)
+                                       * rho_air(k)                            &
+                                            ) * ddzu(k+1) * drho_air_zw(k)
                 ENDDO
              ENDIF
@@ -246,5 +250,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY :  ddzu, ddzw, km, tend, u, v, w
+           ONLY :  ddzu, ddzw, km, tend, u, v, w, drho_air_zw, rho_air
            
        USE control_parameters,                                                 &
@@ -316,6 +320,8 @@
                          & + 2.0_wp * (                                          &
                          &   km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1) &
+                         &               * rho_air(k+1)                          &
                          & - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k) &
-                         &            ) * ddzu(k+1)
+                         &               * rho_air(k)                            &
+                         &            ) * ddzu(k+1) * drho_air_zw(k)
                 ENDIF
              ENDDO
@@ -361,6 +367,8 @@
                                  + 2.0_wp * (                                  &
                            km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1) &
+                                       * rho_air(k+1)                          &
                          - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k) &
-                                            ) * ddzu(k+1)
+                                       * rho_air(k)                            &
+                                            ) * ddzu(k+1) * drho_air_zw(k)
                 ENDIF
              ENDDO
@@ -381,5 +389,5 @@
 
        USE arrays_3d,                                                          &          
-           ONLY :  ddzu, ddzw, km, tend, u, v, w
+           ONLY :  ddzu, ddzw, km, tend, u, v, w, drho_air_zw, rho_air
            
        USE control_parameters,                                                 & 
@@ -430,6 +438,8 @@
                       & + 2.0_wp * (                                           &
                       &   km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1)  &
+                      &               * rho_air(k+1)                           &
                       & - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k)  &
-                      &            ) * ddzu(k+1)
+                      &               * rho_air(k)                             &
+                      &            ) * ddzu(k+1) * drho_air_zw(k)
        ENDDO
 
@@ -485,6 +495,8 @@
                                  + 2.0_wp * (                                  &
                            km(k+1,j,i) * ( w(k+1,j,i) - w(k,j,i) ) * ddzw(k+1) &
+                                       * rho_air(k+1)                          &
                          - km(k,j,i)   * ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k) &
-                                            ) * ddzu(k+1)
+                                       * rho_air(k)                            &
+                                            ) * ddzu(k+1) * drho_air_zw(k)
           ENDDO
        ENDIF
Index: /palm/trunk/SOURCE/disturb_heatflux.f90
===================================================================
--- /palm/trunk/SOURCE/disturb_heatflux.f90	(revision 2036)
+++ /palm/trunk/SOURCE/disturb_heatflux.f90	(revision 2037)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Anelastic approximation implemented
 ! 
 ! Former revisions:
@@ -65,5 +65,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  shf
+        ONLY:  shf, heatflux_input_conversion
         
     USE control_parameters,                                                    &
@@ -76,5 +76,5 @@
     
     USE indices,                                                               &
-        ONLY:  nx, nxl, nxr, ny, nyn, nys, nzb_s_inner
+        ONLY:  nx, nxl, nxr, ny, nyn, nys, nzb, nzb_s_inner
 
     IMPLICIT NONE
@@ -97,9 +97,11 @@
           THEN
              IF ( nzb_s_inner(j,i) == 0 )  THEN
-                shf(j,i) = randomnumber * surface_heatflux
+                shf(j,i) = randomnumber * surface_heatflux                     &
+                           * heatflux_input_conversion(nzb)
              ELSE
 !
 !--             Over topography surface_heatflux is replaced by wall_heatflux(0)
-                shf(j,i) = randomnumber * wall_heatflux(0)
+                shf(j,i) = randomnumber * wall_heatflux(0)                     &
+                           * heatflux_input_conversion(nzb_s_inner(j,i))
              ENDIF
           ENDIF
